
//----------
// TODO
//  - store profile events with function index instead of func name ( log func name on first call )
//  - profile sub blocks
//  - profile single texture
//  - profiler: display main sections in profile timeline for collate index
//  - 
//  - 2 teams : fan reaction
//  - sound mixer
//  - game logic
//  - ball texture map
//  - change ball rotation when fan throws ball
//  - player collision with pole
//  - clean up torus collision functions
//  - memory management
//  - hot load assets
//  - backup path for no persistent buffer extension
//  - debug graphics flicker when fullscreen on some PCs
//----------

enum SCORE_MODE {
	scoreMode_isWaiting,
	scoreMode_isActive,
	scoreMode_isLocked,
};

struct SCORE_STATE {
	int32      score;
	SCORE_MODE mode;
	
	vec3  position;
};

struct APP_STATE {
	boo32 isRunning;
	boo32 isInitialized;
	
	vec2  select_position;
	boo32 select_wasPressed;
	boo32 select_wasReleased;
	
	boo32 move_left;
	boo32 move_right;
	boo32 move_forward;
	boo32 move_backward;
	
	vec2 app_dim;
	vec2 app_halfDim;
	rect app_bound;
	
	vec2 cursor_position;
	
	vec2 player_position;
	vec2 player_velocity;
	
	flo32 player_hAngle;
	vec2  player_hAxis;
	flo32 player_vAngle;
	vec2  player_vAxis;
	vec3  camera_yAxis;
	vec3  camera_zAxis;
	
	vec3 ball_contactPos   [ 2 ];
	vec3 ball_contactNormal[ 2 ];
	
	boo32 player_isHoldingBall;
	flo32 player_shotPower;
	
	vec3 ball_position;
	vec3 ball_velocity;
	
	quat  ball_orientation;
	vec3  ball_rotateAxis;
	flo32 ball_radians;
	flo32 ball_rotateVelocity;
	
	SCORE_STATE scoreState_home;
	SCORE_STATE scoreState_away;
	
	PERM_MESH mesh_stadiumSeat;
	PERM_MESH mesh_stadiumSeats;
	
	boo32 showControls;
	boo32 helpTutorial_counter;
	flo32 helpTutorial_timer;
	
	flo32 anim_timer;
	vec3 bone[ 3 ];
	
	flo32 jumbotron_timer;
	
	vec3   fanMesh_position[ 72 ];
	vec2   fanMesh_texCoord[ 80 ];
	uint32 fanMesh_posIndex[ 336 ];
	uint32 fanMesh_texIndex[ 336 ];
	
	int32 currentFan_index;
	vec3  currentFan_boundPos;
	vec3  currentFan_boundXAxis;
	vec3  currentFan_boundZAxis;
	vec3  currentFan_velocity;
	
	vec3   stadiumFan_position [ 2248 ];
	flo32  stadiumFan_rotation [    8 ];
	flo32  stadiumFan_radians  [ 2248 ];
	flo32  stadiumFan_t        [ 2248 ];
	uint32 stadiumFan_texSelect[ 2248 ];
	flo32  stadiumFan_rate     [ 2248 ];
	
	int32 fanCheer_bufferCount;
	int32 fanCheer_buffer     [ 2248 ];
	int32 fanCheer_repeatCount[ 2248 ];
	
	int32 fanWave_repeatCount;
	int32 fanWave_counter;
	
	int32 fanWave_column_baseIndex[ 156 ];
	int32 fanWave_column_count    [ 156 ];
	flo32 fanWave_timer;
	int32 fanWave_index;
	
	flo32 fanWave_initTimer;
	flo32 fanWave_initTargetTime;
	
	#define FAN_WAVE__BUFFER_COUNT  ( 5 )
	int32 fanWave_bufferSelect;
	int32 fanWave_buffer[   FAN_WAVE__BUFFER_COUNT * 20 ];
	int32 fanWave_inBuffer[ FAN_WAVE__BUFFER_COUNT      ];
	
#if DEBUG_BUILD
	vec3 shot_position;
	vec3 shot_ballPos;
	vec3 shot_velocity;
	vec3 shot_xAxis;
	vec3 shot_yAxis;
	vec3 shot_zAxis;
	flo32 shot_hDegrees;
#endif // DEBUG_BUILD
};