
internal void
genStadiumSeat() {
	int32 vertex_count = 48 + 36;
	int32 size = sizeof( VERTEX_TEXMESH_3D ) * vertex_count + sizeof( MESH_DRAW_TYPE ) + sizeof( int32 );
	
	MEMORY  _memory = Memory( malloc( size ), size );
	MEMORY * memory = &_memory;
	
	_writem( memory, MESH_DRAW_TYPE, meshDrawType_triangles );
	_writem( memory, int32,          vertex_count           );
	
	{ // base
		flo32 height = 0.5f;
		vec2  dim    = Vec2( 0.2f, 0.2f );
		rect  bound  = rectCD( Vec2( 0.0f, 0.0f ), dim );
		
		vec3 vertex[] = {
			Vec3( bound.left, 0.0f,   bound.top ),  Vec3( bound.right, 0.0f,   bound.top ), Vec3( bound.right, 0.0f,   bound.bottom ), Vec3( bound.left, 0.0f,   bound.bottom ),
			Vec3( bound.left, height, bound.top ),  Vec3( bound.right, height, bound.top ), Vec3( bound.right, height, bound.bottom ), Vec3( bound.left, height, bound.bottom ),
		};
		
		vec2 texCoord[] = {
			Vec2( 0.0f, 0.0f ), Vec2( 0.2857f, 0.0f ), Vec2( 0.2857f, 1.0f ), Vec2( 0.0f, 1.0f ),
		};
		
		addVertex( memory, vertex[ 0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 1 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 5 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 5 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 4 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[ 1 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 2 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 6 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 1 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 6 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 5 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[ 2 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 3 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 7 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 2 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 7 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 6 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[ 3 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 0 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 4 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 3 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 4 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 7 ], texCoord[ 3 ] );
	}
	
	{ // seat
		flo32 height    = 0.9f;
		flo32 thickness = 0.15f;
		flo32 halfWidth = 0.4f;
		flo32 halfDepth = 0.4f;
		flo32 angle = PI * ( 10.0f / 180.0f );
		
		flo32 widthA = -halfWidth;
		flo32 widthB =  halfWidth;
		
		flo32 heightA = 0.5f;
		flo32 heightB = heightA + thickness;
		flo32 heightC = heightA + cosf( angle ) * height;
		flo32 heightD = heightC + sinf( angle ) * thickness;
		
		flo32 depthA =  halfDepth + sinf( angle ) * height;
		flo32 depthB =  depthA    - cosf( angle ) * thickness;
		flo32 depthC =  halfDepth;
		flo32 depthD =  halfDepth - thickness;
		flo32 depthE = -halfDepth;
		
		
		vec3 vertex[] = {
			Vec3( widthB, heightA, depthC ), Vec3( widthB, heightA, depthE ), Vec3( widthB, heightB, depthE ),
			Vec3( widthB, heightB, depthD ), Vec3( widthB, heightD, depthB ), Vec3( widthB, heightC, depthA ),
			
			Vec3( widthA, heightA, depthC ), Vec3( widthA, heightA, depthE ), Vec3( widthA, heightB, depthE ),
			Vec3( widthA, heightB, depthD ), Vec3( widthA, heightD, depthB ), Vec3( widthA, heightC, depthA ),
		};
		
		vec2 texCoord[] = {
			Vec2( 0.2857f, 0.0f ), Vec2( 1.0f, 0.0f ), Vec2( 1.0f, 1.0f ), Vec2( 0.2857f, 1.0f ),
		};
		
		addVertex( memory, vertex[  0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  1 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  2 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  2 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  3 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  3 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  4 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  4 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  5 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  6 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  8 ], texCoord[ 3 ] );
		addVertex( memory, vertex[  7 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  6 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  9 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  8 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  6 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 10 ], texCoord[ 3 ] );
		addVertex( memory, vertex[  9 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  6 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 11 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 10 ], texCoord[ 3 ] );
		
		
		addVertex( memory, vertex[  1 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  7 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  8 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  1 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  8 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  2 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  2 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  8 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  9 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  2 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  9 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  3 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  3 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  9 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 10 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  3 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 10 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  4 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  4 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 10 ], texCoord[ 1 ] );
		addVertex( memory, vertex[ 11 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  4 ], texCoord[ 0 ] );
		addVertex( memory, vertex[ 11 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  5 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  6 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  0 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  5 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  6 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  5 ], texCoord[ 2 ] );
		addVertex( memory, vertex[ 11 ], texCoord[ 3 ] );
		
		addVertex( memory, vertex[  0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  6 ], texCoord[ 1 ] );
		addVertex( memory, vertex[  7 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  0 ], texCoord[ 0 ] );
		addVertex( memory, vertex[  7 ], texCoord[ 2 ] );
		addVertex( memory, vertex[  1 ], texCoord[ 3 ] );
	}
	
	FILE * output = fopen( "../../art/stadiumSeat.raw", "wb" );
	if( output ) {
		int32 bytesWritten = ( int32 )fwrite( memory->base, 1, memory->used, output );
		Assert( bytesWritten == size );
		
		free( memory->base );
		fclose( output );
	} else {
		InvalidCodePath;
	}
}

internal void
genStadiumSeats( flo32 court_halfWidth, flo32 court_halfLength ) {
	int32 vertex_count = 2248 * 84;
	int32 size = sizeof( VERTEX_TEXMESH_3D ) * vertex_count + sizeof( MESH_DRAW_TYPE ) + sizeof( int32 );
	
	MEMORY  _memory = Memory( malloc( size ), size );
	MEMORY * memory = &_memory;
	
	FILE * input = fopen( "../../art/stadiumSeat.raw", "rb" );
	Assert( input );
	
	fseek( input, 0, SEEK_END );
	int32 input_size = ftell( input );
	fseek( input, 0, SEEK_SET );
	
	uint8 * input_data = ( uint8 * )malloc( input_size );
	int32 bytesRead = ( int32 )fread( input_data, 1, input_size, input );
	Assert( bytesRead == input_size );
	
	fclose( input );
	
	VERTEX_TEXMESH_3D * vertex = ( VERTEX_TEXMESH_3D * )( input_data + ( sizeof( MESH_DRAW_TYPE ) + sizeof( int32 ) ) );
	
	_writem( memory, MESH_DRAW_TYPE, meshDrawType_triangles );
	_writem( memory, int32,          vertex_count           );
	
	flo32 dY = 2.0f;
	{ // seat section A
		int32  row_count = 16;
		int32 seat_count = 15;
		
		flo32 xStride = 1.5f;
		flo32 yStride = dY / ( flo32 )row_count;
		flo32 zStride = 0.825f;
		
		vec3 basePos   = Vec3( court_halfWidth + 4.0f, -0.2f, 2.0f );
		mat4 rotationA = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ),    PI * 0.5f   ) );
		mat4 rotationB = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ), -( PI * 0.5f ) ) );
		for( int32 row_index = 0; row_index < row_count; row_index++ ) {
			flo32 xPos = basePos.x + xStride * ( flo32 )row_index;
			flo32 yPos = basePos.y + yStride * ( flo32 )row_index;
			if( row_index > 4 ) {
				yPos += ( yStride * ( flo32 )( row_index - 4 ) );
			}
			if( row_index > 9 ) {
				yPos += ( yStride * ( flo32 )( row_index - 9 ) );
			}
			for( int32 seat_index = 0; seat_index < seat_count; seat_index++ ) {
				flo32 zPos = basePos.z + zStride * ( flo32 )seat_index;
				vec3 positionA = Vec3(  xPos, yPos,  zPos );
				vec3 positionB = Vec3(  xPos, yPos, -zPos );
				vec3 positionC = Vec3( -xPos, yPos,  zPos );
				vec3 positionD = Vec3( -xPos, yPos, -zPos );
				
				mat4 transformA = mat4_translate( positionA ) * rotationA;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformA * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
				
				mat4 transformB = mat4_translate( positionB ) * rotationA;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformB * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
				
				mat4 transformC = mat4_translate( positionC ) * rotationB;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformC * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
				
				mat4 transformD = mat4_translate( positionD ) * rotationB;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformD * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
			}
		}
	}
	
	{ // seat section B
		int32  row_count = 14;
		int32 seat_count = 18;
		
		flo32 xStride = 0.825f;
		flo32 yStride = dY / ( flo32 )row_count;
		flo32 zStride = 1.5f;
		
		vec3 basePos = Vec3( -xStride * 8.5f, -0.2f, court_halfLength + 4.0f );
		mat4 rotationA = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ), 0.0f ) );
		mat4 rotationB = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ), PI   ) );
		for( int32 row_index = 0; row_index < row_count; row_index++ ) {
			flo32 yPos = basePos.y + yStride * ( flo32 )row_index;
			if( row_index > 3 ) {
				yPos += ( yStride * ( flo32 )( row_index - 3 ) );
			}
			if( row_index > 8 ) {
				yPos += ( yStride * ( flo32 )( row_index - 8 ) );
			}
			
			flo32 zPos = basePos.z + zStride * ( flo32 )row_index;
			for( int32 seat_index = 0; seat_index < seat_count; seat_index++ ) {
				flo32 xPos = basePos.x + xStride * ( flo32 )seat_index;
				vec3 positionA = Vec3(  xPos, yPos,  zPos );
				vec3 positionB = Vec3(  xPos, yPos, -zPos );
				
				mat4 transformA = mat4_translate( positionA ) * rotationA;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformA * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
				
				mat4 transformB = mat4_translate( positionB ) * rotationB;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformB * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
			}
		}
	}
	
	{ // seat section C
		int32  row_count = 12;
		// int32 seat_count = 18;
		
		flo32 xStride = 0.825f;
		flo32 yStride = dY / ( flo32 )row_count;
		flo32 zStride = 1.5f;
		
		flo32 stadiumFan_radians = -( PI * 0.75f );
		vec2 seat_vector = Vec2( -cosf( stadiumFan_radians ),  sinf( stadiumFan_radians ) ) * xStride;
		vec2  row_vector = Vec2(  cosf( stadiumFan_radians ),  sinf( stadiumFan_radians ) ) * zStride;
		
		mat4 rotationA = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ), stadiumFan_radians ) );
		mat4 rotationB = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ), stadiumFan_radians - ( PI * 0.5f ) ) );
		mat4 rotationC = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ), stadiumFan_radians + ( PI * 0.5f ) ) );
		mat4 rotationD = mat4_toRotation( Quat( Vec3( 0.0f, 1.0f, 0.0f ), stadiumFan_radians + PI ) );
		
		vec2 basePos = Vec2( -( court_halfWidth - cosf( stadiumFan_radians ) * 4.0f ), -( court_halfLength - sinf( stadiumFan_radians ) * 4.0f ) );
		for( int32 row_index = 0; row_index < row_count; row_index++ ) {
			int32 seat_count = ( int32 )lerp( 2.0f, ( flo32 )row_index / ( flo32 )row_count, 34.0f );
			vec2     row_pos = basePos + row_vector * ( flo32 )row_index - seat_vector * ( ( flo32 )( seat_count - 1 ) * 0.5f );
			flo32 yPos = -0.2f + yStride * ( flo32 )row_index;
			if( row_index > 3 ) {
				yPos += ( yStride * ( flo32 )( row_index - 3 ) );
			}
			if( row_index > 7 ) {
				yPos += ( yStride * ( flo32 )( row_index - 7 ) );
			}
			for( int32 seat_index = 0; seat_index < seat_count; seat_index++ ) {
				vec2 seat_pos = row_pos + seat_vector * ( flo32 )seat_index;
				
				vec3 positionA = Vec3(  seat_pos.x, yPos,  seat_pos.y );
				vec3 positionB = Vec3( -seat_pos.x, yPos,  seat_pos.y );
				vec3 positionC = Vec3(  seat_pos.x, yPos, -seat_pos.y );
				vec3 positionD = Vec3( -seat_pos.x, yPos, -seat_pos.y );
				
				mat4 transformA = mat4_translate( positionA ) * rotationA;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformA * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
				
				mat4 transformB = mat4_translate( positionB ) * rotationB;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformB * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
				
				mat4 transformC = mat4_translate( positionC ) * rotationC;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformC * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
				
				mat4 transformD = mat4_translate( positionD ) * rotationD;
				for( int32 iter = 0; iter < 84; iter++ ) {
					vec3 position = vertex[ iter ].position;
					vec2 texCoord = vertex[ iter ].texCoord;
					
					vec3 adjPos = ( transformD * Vec4( position, 1.0f ) ).xyz;
					_writem( memory, vec3, adjPos );
					_writem( memory, vec2, texCoord );
				}
			}
		}
	}
	
	free( input_data );
	
	FILE * output = fopen( "../../art/stadiumSeats.raw", "wb" );
	if( output ) {
		int32 bytesWritten = ( int32 )fwrite( memory->base, 1, memory->used, output );
		Assert( bytesWritten == size );
		
		free( memory->base );
		fclose( output );
	} else {
		InvalidCodePath;
	}
}

internal void
genJumbotron() {
	flo32 radians = PI / 9.0f;
	
	flo32 halfDimA = 4.0f;
	flo32 halfDimB = halfDimA + sinf( radians ) * 6.0f;
	flo32 heightB   = 18.0f;
	flo32 heightA   = 18.0f - cosf( radians ) * 6.0f;
	
	vec3 pos[] = {
		Vec3( -halfDimA, heightA, -halfDimA ),   Vec3( -halfDimA, heightA,  halfDimA ),   Vec3(  halfDimA, heightA,  halfDimA ),   Vec3(  halfDimA, heightA, -halfDimA ),
		Vec3( -halfDimB, heightB, -halfDimA ),   Vec3( -halfDimB, heightB,  halfDimA ),   Vec3( -halfDimA, heightB,  halfDimB ),   Vec3(  halfDimA, heightB,  halfDimB ),
		Vec3(  halfDimB, heightB,  halfDimA ),   Vec3(  halfDimB, heightB, -halfDimA ),   Vec3(  halfDimA, heightB, -halfDimB ),   Vec3( -halfDimA, heightB, -halfDimB ),
	};
	
	{ // gen jumbotron mesh
		int32 vertex_count = 42;
		int32 size = sizeof( VERTEX_TEXMESH_3D ) * vertex_count + sizeof( MESH_DRAW_TYPE ) + sizeof( int32 );
		
		MEMORY  _memory = Memory( malloc( size ), size );
		MEMORY * memory = &_memory;
		
		_writem( memory, MESH_DRAW_TYPE, meshDrawType_triangles );
		_writem( memory, int32,          vertex_count           );
		
		vec2 tex[] = { Vec2( 0.0f, 0.0f ), Vec2( 1.0f, 0.0f ), Vec2( 1.0f, 1.0f ), Vec2( 0.0f, 1.0f ) };
		for( int32 iter = 0; iter < 4; iter++ ) {
			int32 indexA =   iter;
			int32 indexB = ( iter + 1 ) % 4;
			
			int32 indexC = 4 +     ( iter * 2 );
			int32 indexD = 4 +     ( iter * 2 ) + 1;
			int32 indexE = 4 + ( ( ( iter * 2 ) + 2 ) % 8 );
			
			vec3 pos0[] = { pos[ indexA ], pos[ indexB ], pos[ indexC ], pos[ indexD ], pos[ indexE ] };
			addQuad( memory, pos0[ 0 ], pos0[ 1 ], pos0[ 3 ], pos0[ 2 ], tex );
			addTri(  memory, pos0[ 1 ], pos0[ 4 ], pos0[ 3 ], Vec2( 0.0f, 0.0f ) );
		}
		addQuad( memory, pos[ 1 ], pos[ 0 ], pos[ 3 ], pos[ 2 ], Vec2( 0.0f, 0.0f ) );
		
		FILE * output = fopen( "../../art/jumbotron.raw", "wb" );
		if( output ) {
			int32 bytesWritten = ( int32 )fwrite( memory->base, 1, memory->used, output );
			Assert( bytesWritten == size );
			
			free( memory->base );
			fclose( output );
		} else {
			InvalidCodePath;
		}
	}
	
	{ // gen jumbotron text
		int32 vertex_count = 13;
		int32 memory_size = sizeof( MESH_DRAW_TYPE ) + sizeof( int32 ) + vertex_count * sizeof( vec3 );
		
		MEMORY  _memory = Memory( malloc( memory_size ), memory_size );
		MEMORY * memory = &_memory;
		
		_writem( memory, MESH_DRAW_TYPE, meshDrawType_null );
		_writem( memory, int32,          vertex_count      );
		vec3 * vertex = _pushArray( memory, vec3, vertex_count );
		
		flo32 char_width0  = 1.0f;
		flo32 char_height0 = 1.3333f;
		
		flo32 char_width1  = 0.5f;
		flo32 char_height1 = 0.6667f;
		
		vec3 basePos = Vec3( 0.0f, heightA, halfDimA );
		
		vec3 xAxis = Vec3( 1.0f, 0.0f, 0.0f );
		vec3 yAxis = Vec3( 0.0f, cosf( radians ), sinf( radians ) );
		
		flo32 offsetX0 = 0.81f;
		flo32 offsetX1 = 0.1f;
		flo32 offsetX2 = 0.15f;
		flo32 offsetX3 = 0.1f;
		flo32 offsetY0 = 0.95f;
		flo32 offsetY1 = 4.7f;
		vec3  offsetZ  = getNormal( cross( xAxis, yAxis ) ) * 0.001f;
		
		vertex[  0 ] = basePos;
		vertex[  1 ] = xAxis * char_width0;
		vertex[  2 ] = yAxis * char_height0;
		vertex[  3 ] = xAxis * char_width1;
		vertex[  4 ] = yAxis * char_height1;
		vertex[  5 ] = -xAxis * ( char_width0 * 2.0f + offsetX0 + offsetX1 ) + yAxis * offsetY0 + offsetZ;
		vertex[  6 ] = -xAxis * ( char_width0        + offsetX0            ) + yAxis * offsetY0 + offsetZ;
		vertex[  7 ] =  xAxis * (                      offsetX0            ) + yAxis * offsetY0 + offsetZ;
		vertex[  8 ] =  xAxis * ( char_width0        + offsetX0 + offsetX1 ) + yAxis * offsetY0 + offsetZ;
		vertex[  9 ] = -xAxis * ( char_width1 * 2.0f + offsetX2 + offsetX3 ) + yAxis * offsetY1 + offsetZ;
		vertex[ 10 ] = -xAxis * ( char_width1        + offsetX2            ) + yAxis * offsetY1 + offsetZ;
		vertex[ 11 ] =  xAxis * (                      offsetX2            ) + yAxis * offsetY1 + offsetZ;
		vertex[ 12 ] =  xAxis * ( char_width1        + offsetX2 + offsetX3 ) + yAxis * offsetY1 + offsetZ;
	
		FILE * output = fopen( "../../art/jumbotronText.raw", "wb" );
		if( output ) {
			int32 bytesWritten = ( int32 )fwrite( memory->base, 1, memory->used, output );
			Assert( bytesWritten == memory_size );
			
			free( memory->base );
			fclose( output );
		} else {
			InvalidCodePath;
		}
	}
	
	{ // gen collision
		int32    collisionMemory_size = sizeof( COLLISION_GEOMETRY ) + sizeof( vec3 ) * ( 4 * 5 + 3 * 4 + 2 * 12 + 4 );
		MEMORY  _collisionMemory      = Memory( malloc( collisionMemory_size ), collisionMemory_size );
		MEMORY * collisionMemory     = &_collisionMemory;
		
		COLLISION_GEOMETRY * collisionGeometry = _pushType_clear( collisionMemory, COLLISION_GEOMETRY );
		addQuad( collisionGeometry, collisionMemory, pos[ 1 ], pos[ 0 ], pos[  3 ], pos[  2 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 0 ], pos[ 1 ], pos[  5 ], pos[  4 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 1 ], pos[ 2 ], pos[  7 ], pos[  6 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 2 ], pos[ 3 ], pos[  9 ], pos[  8 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 3 ], pos[ 0 ], pos[ 11 ], pos[ 10 ] );
		addTri( collisionGeometry, collisionMemory, pos[ 0 ], pos[  4 ], pos[ 11 ] );
		addTri( collisionGeometry, collisionMemory, pos[ 1 ], pos[  6 ], pos[  5 ] );
		addTri( collisionGeometry, collisionMemory, pos[ 2 ], pos[  8 ], pos[  7 ] );
		addTri( collisionGeometry, collisionMemory, pos[ 3 ], pos[ 10 ], pos[  9 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 0 ], pos[ 1 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 1 ], pos[ 2 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 2 ], pos[ 3 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 3 ], pos[ 0 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 0 ], pos[ 11 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 0 ], pos[  4 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 1 ], pos[  5 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 1 ], pos[  6 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 2 ], pos[  7 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 2 ], pos[  8 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 3 ], pos[  9 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 3 ], pos[ 10 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 0 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 1 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 2 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 3 ] );
	
		FILE * output = fopen( "../../art/jumbotron.col", "wb" );
		if( output ) {
			int32 bytesWritten = ( int32 )fwrite( collisionMemory->base, 1, collisionMemory->used, output );
			Assert( bytesWritten == collisionMemory_size );
			
			free( collisionMemory->base );
			fclose( output );
		} else {
			InvalidCodePath;
		}
	}
}

internal void
genHoopCollision() {
	flo32 backboard_halfWidth  = 1.8f  * 0.5f;
	flo32 backboard_height     = 1.05f;
	flo32 backboard_halfDepth  = 0.1f  * 0.5f;
	
	flo32 pole_height = 3.05f;
	flo32 pole_radius = 0.05f;
	
	flo32 rim_offset = 0.275f;
	flo32 rim_height = 3.2f;
	flo32 rim_majorRadius = 0.2286f;
	flo32 rim_minorRadius = 0.005f;
	
	flo32  width[] = { -backboard_halfWidth, backboard_halfWidth, };
	flo32 height[] = {  pole_height, pole_height + backboard_height, };
	flo32  depth[] = { -backboard_halfDepth, backboard_halfDepth, };
	
	vec3 pos[] = {
		Vec3( width[ 0 ], height[ 0 ], depth[ 1 ] ),
		Vec3( width[ 1 ], height[ 0 ], depth[ 1 ] ),
		Vec3( width[ 1 ], height[ 1 ], depth[ 1 ] ),
		Vec3( width[ 0 ], height[ 1 ], depth[ 1 ] ),
		Vec3( width[ 0 ], height[ 0 ], depth[ 0 ] ),
		Vec3( width[ 1 ], height[ 0 ], depth[ 0 ] ),
		Vec3( width[ 1 ], height[ 1 ], depth[ 0 ] ),
		Vec3( width[ 0 ], height[ 1 ], depth[ 0 ] ),
	};
	
	{ // gen collision
		int32    collisionMemory_size = sizeof( COLLISION_GEOMETRY ) + collisionGeometry_getDataSize( 6, 0, 12, 8, 1, 1 );
		MEMORY  _collisionMemory      = Memory( malloc( collisionMemory_size ), collisionMemory_size );
		MEMORY * collisionMemory     = &_collisionMemory;
		
		COLLISION_GEOMETRY * collisionGeometry = _pushType_clear( collisionMemory, COLLISION_GEOMETRY );
		addQuad( collisionGeometry, collisionMemory, pos[ 0 ], pos[ 1 ], pos[ 2 ], pos[ 3 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 1 ], pos[ 5 ], pos[ 6 ], pos[ 2 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 5 ], pos[ 4 ], pos[ 7 ], pos[ 6 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 4 ], pos[ 0 ], pos[ 3 ], pos[ 7 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 3 ], pos[ 2 ], pos[ 6 ], pos[ 7 ] );
		addQuad( collisionGeometry, collisionMemory, pos[ 4 ], pos[ 5 ], pos[ 1 ], pos[ 0 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 0 ], pos[ 1 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 1 ], pos[ 2 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 2 ], pos[ 3 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 3 ], pos[ 0 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 4 ], pos[ 5 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 5 ], pos[ 6 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 6 ], pos[ 7 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 7 ], pos[ 4 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 0 ], pos[ 3 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 1 ], pos[ 2 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 5 ], pos[ 6 ] );
		addEdge( collisionGeometry, collisionMemory, pos[ 4 ], pos[ 7 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 0 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 1 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 2 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 3 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 4 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 5 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 6 ] );
		addPoint( collisionGeometry, collisionMemory, pos[ 7 ] );
		addCylinder( collisionGeometry, collisionMemory, Vec3( 0.0f, 0.0f,        0.0f ), Vec3( 0.0f, pole_height, 0.0f ), pole_radius );
		addTorus( collisionGeometry, collisionMemory, Vec3( 0.0f, rim_height, rim_offset ), Vec3( 0.0f, 1.0f, 0.0f ), rim_majorRadius, rim_minorRadius );
	
		FILE * output = fopen( "../../art/basketballHoop.col", "wb" );
		if( output ) {
			int32 bytesWritten = ( int32 )fwrite( collisionMemory->base, 1, collisionMemory->used, output );
			Assert( bytesWritten == collisionMemory_size );
			
			free( collisionMemory->base );
			fclose( output );
		} else {
			InvalidCodePath;
		}
	}
}

internal void
genPlayerWalkBound( vec2 * stadium_rowAxis, vec2 * stadium_seatAxis, vec2 * stadium_basePos, int32 * stadium_rowCount, int32 * row0_seatCount, int32 * rowN_seatCount ) {
	COLLISION_GEOMETRY__TEMP_BUFFER * tempBuffer = ( COLLISION_GEOMETRY__TEMP_BUFFER * )calloc( sizeof( COLLISION_GEOMETRY__TEMP_BUFFER ), 1 );
	
	int32 walkBound_count = 0;
	vec2  walkBound[ 40 ] = {};
	
	for( int32 section_index = 0; section_index < 10; section_index++ ) {
		vec2  row_axis = stadium_rowAxis[  section_index ];
		vec2 seat_axis = stadium_seatAxis[ section_index ];
		
		vec2 basePos = stadium_basePos[ section_index ];
		
		int32 row_count = stadium_rowCount[ section_index ];
		flo32 yStride   = 2.0f / ( flo32 )row_count;
		
		flo32 row0_count = ( flo32 )( row0_seatCount[ section_index ] - 1 ) * 0.5f;
		flo32 rowN_count = ( flo32 )( rowN_seatCount[ section_index ] - 1 ) * 0.5f;
		
		vec2 walkBound_offset[ 4 ] = { seat_axis * 0.5f, ( seat_axis - row_axis ) * 0.5f, ( -seat_axis - row_axis ) * 0.5f, -seat_axis * 0.5f, };
		vec2  point[ 4 ] = {
			basePos + row_axis * ( flo32 )( row_count - 1 ) + seat_axis * rowN_count, basePos + seat_axis * row0_count,
			basePos - seat_axis * row0_count, basePos + row_axis * ( flo32 )( row_count - 1 ) - seat_axis * rowN_count,
		};
		
		for( int32 iter = 0; iter < 4; iter++ ) {
			walkBound[ walkBound_count++ ] = point[ iter ] + walkBound_offset[ iter ];
		}
	}
	
	for( int32 walkBound_index = 0; walkBound_index < walkBound_count; walkBound_index++ ) {
		int32 indexA = ( walkBound_index + 1 ) % walkBound_count;
		int32 indexB =   walkBound_index;
		
		addEdge( tempBuffer, walkBound[ indexA ], walkBound[ indexB ] );
	}
	for( int32 walkBound_index = 1; walkBound_index < walkBound_count; walkBound_index += 4 ) {
		addPoint( tempBuffer, walkBound[ walkBound_index     ] );
		addPoint( tempBuffer, walkBound[ walkBound_index + 1 ] );
	}
	
	int32    collisionMemory_size = getSize2D( tempBuffer );
	MEMORY  _collisionMemory      = Memory( malloc( collisionMemory_size ), collisionMemory_size );
	MEMORY * collisionMemory      = &_collisionMemory;
	
	packGeometry2D( collisionMemory, tempBuffer );

	FILE * output = fopen( "../../art/walkBound.col", "wb" );
	if( output ) {
		int32 bytesWritten = ( int32 )fwrite( collisionMemory->base, 1, collisionMemory->used, output );
		Assert( bytesWritten == collisionMemory_size );
		
		free( tempBuffer );
		free( collisionMemory->base );
		fclose( output );
	} else {
		InvalidCodePath;
	}
}

internal void
genStadium( vec2 * stadium_rowAxis, vec2 * stadium_seatAxis, vec2 * stadium_basePos, int32 * stadium_rowCount, int32 * row0_seatCount, int32 * rowN_seatCount, int32 * stadium_seatCount, int32 * stadium_gradientIndex, int32 * corner_seatCount ) {
	vec3  floor_vertex[ 80 ] = {};
	int32 floor_vertexIndex  = 0;
	
	flo32 court_halfWidth  = COURT__HALF_WIDTH;
	flo32 court_halfLength = COURT__HALF_LENGTH;
	
	vec3 court_pos[] = {
		Vec3(  court_halfWidth, 0.0f,  court_halfLength ),
		Vec3(  court_halfWidth, 0.0f, -court_halfLength ),
		Vec3( -court_halfWidth, 0.0f, -court_halfLength ),
		Vec3( -court_halfWidth, 0.0f,  court_halfLength ),
	};
	
	vec3 offsetA = Vec3( 0.0f, 10.0f, 0.0f );
	vec3 offsetB = Vec3( 0.0f, 18.0f, 0.0f );
	
	for( int32 section_index = 0; section_index < 10; section_index++ ) {
		vec2  row_axis = stadium_rowAxis[  section_index ];
		vec2 seat_axis = stadium_seatAxis[ section_index ];
		
		vec2 basePos = stadium_basePos[ section_index ];
		
		int32 row_count = stadium_rowCount[ section_index ];
		flo32 yStride   = 2.0f / ( flo32 )row_count;
		
		flo32 row0_count = ( flo32 )( row0_seatCount[ section_index ] - 1 ) * 0.5f;
		flo32 rowN_count = ( flo32 )( rowN_seatCount[ section_index ] - 1 ) * 0.5f;
		
		vec2       row_offset      =  row_axis * 0.3333f;
		vec2      seat_offset      = seat_axis * 0.5f;
		
		int32 seat_count = stadium_seatCount[ section_index ];
		int32 * gradientIndex = stadium_gradientIndex + ( section_index * 2 );
		for( int32 row_index = 0; row_index < row_count; row_index++ ) {
			if( ( section_index == 2 ) || ( section_index == 4 ) || ( section_index == 7 ) || ( section_index == 9 ) ) {
				seat_count = corner_seatCount[ row_index ];
			}
			
			flo32 yPos = yStride * ( flo32 )row_index;
			if( row_index > gradientIndex[ 0 ] ) {
				yPos += ( yStride * ( flo32 )( row_index - gradientIndex[ 0 ] ) );
			}
			if( row_index > gradientIndex[ 1 ] ) {
				yPos += ( yStride * ( flo32 )( row_index - gradientIndex[ 1 ] ) );
			}
			
			vec2 atPos = basePos + row_axis * ( flo32 )row_index - seat_axis * ( ( flo32 )( seat_count - 1 ) * 0.5f );
			
			if( ( row_index == 0 ) || ( row_index == gradientIndex[ 0 ] ) || ( row_index == gradientIndex[ 1 ] ) || ( row_index == ( row_count - 1 ) ) ) {
				vec2 posA = atPos - seat_offset + row_offset;
				vec2 posB = posA + seat_axis * ( flo32 )seat_count;
				
				floor_vertex[ floor_vertexIndex++ ] = Vec3( posA.x, yPos, posA.y );
				floor_vertex[ floor_vertexIndex++ ] = Vec3( posB.x, yPos, posB.y );
			}
		}
	}
	
	{ // gen mesh
		int32 vertex_count = 726;
		int32 size = sizeof( VERTEX_TEXMESH_3D ) * vertex_count + sizeof( MESH_DRAW_TYPE ) + sizeof( int32 );
		
		MEMORY  _memory = Memory( malloc( size ), size );
		MEMORY * memory = &_memory;
		
		_writem( memory, MESH_DRAW_TYPE, meshDrawType_triangles );
		_writem( memory, int32,          vertex_count           );
		
		vec2 tex[] = {
			Vec2( 0.0f,    0.0f ),  Vec2( 0.3333f, 0.0f ),  Vec2( 0.3333f, 1.0f ),  Vec2( 0.0f,    1.0f ),
			Vec2( 0.3333f, 0.0f ),  Vec2( 0.6667f, 0.0f ),  Vec2( 0.6667f, 1.0f ),  Vec2( 0.3333f, 1.0f ),
			Vec2( 0.6667f, 0.0f ),  Vec2( 1.0f,    0.0f ),  Vec2( 1.0f,    1.0f ),  Vec2( 0.6667f, 1.0f ),
		};
		
		for( int32 section_index = 0; section_index < 10; section_index++ ) {
			int32 indexA =     section_index;
			int32 indexB = ( ( section_index + 1 ) % 10 );
			
			vec3 * posA = floor_vertex + ( indexA * 8 );
			vec3 * posB = floor_vertex + ( indexB * 8 );
			
			for( int32 iter = 0; iter < 3; iter++ ) {
				int32 base = iter * 2;
				addQuad( memory, posA[ base + 0 ], posA[ base + 1 ], posA[ base + 3 ], posA[ base + 2 ], tex + 0 );
				addQuad( memory, posB[ base + 1 ], posA[ base + 0 ], posA[ base + 2 ], posB[ base + 3 ], tex + 0 );
			}
			
			addQuad( memory, posA[ 6 ], posA[ 7 ], posA[ 7 ] + offsetA, posA[ 6 ] + offsetA, tex + 4 );
			addQuad( memory, posB[ 7 ], posA[ 6 ], posA[ 6 ] + offsetA, posB[ 7 ] + offsetA, tex + 4 );
			
			addQuad( memory, posA[ 6 ] + offsetA, posA[ 7 ] + offsetA, posA[ 1 ] + offsetB, posA[ 0 ] + offsetB, tex + 8 );
			addQuad( memory, posB[ 7 ] + offsetA, posA[ 6 ] + offsetA, posA[ 0 ] + offsetB, posB[ 1 ] + offsetB, tex + 8 );
		}
	
		int32 baseIndex[] = { 0, 1, 2, 2, 3,   3, 3, 4, 4, 5,   5, 6, 7, 7, 8,   8, 8, 9, 9, 0, };
		for( int32 section_index = 0; section_index < 4; section_index++ ) {
			int32 indexA =     section_index;
			int32 indexB = ( ( section_index + 1 ) % 4 );
			
			int32 * base = baseIndex + ( section_index * 5 );
			
			vec3 pos[] = {
				court_pos[ indexA ], court_pos[ indexB ],  ( floor_vertex + ( base[ 0 ] * 8 ) )[ 1 ], ( floor_vertex + ( base[ 1 ] * 8 ) )[ 0 ],
				( floor_vertex + ( base[ 2 ] * 8 ) )[ 1 ], ( floor_vertex + ( base[ 3 ] * 8 ) )[ 0 ], ( floor_vertex + ( base[ 4 ] * 8 ) )[ 1 ], 
			};
			
			addQuad( memory, pos[ 1 ], pos[ 0 ], pos[ 2 ], pos[ 3 ], tex + 0 );
			addTri(  memory, pos[ 1 ], pos[ 3 ], pos[ 4 ], tex + 0 );
			addTri(  memory, pos[ 1 ], pos[ 4 ], pos[ 5 ], tex + 0 );
			addTri(  memory, pos[ 1 ], pos[ 5 ], pos[ 6 ], tex + 0 );
			
			for( int32 iter = 0; iter < 7; iter++ ) { pos[ iter ] += offsetB; }
			
			addQuad( memory, pos[ 3 ], pos[ 2 ], pos[ 0 ], pos[ 1 ], tex + 8 );
			addTri(  memory, pos[ 1 ], pos[ 4 ], pos[ 3 ], tex + 8 );
			addTri(  memory, pos[ 1 ], pos[ 5 ], pos[ 4 ], tex + 8 );
			addTri(  memory, pos[ 1 ], pos[ 6 ], pos[ 5 ], tex + 8 );
		}
		
		addQuad( memory, court_pos[ 3 ] + offsetB, court_pos[ 2 ] + offsetB, court_pos[ 1 ] + offsetB, court_pos[ 0 ] + offsetB, tex + 8 );
		
		FILE * output = fopen( "../../art/stadiumFloor.raw", "wb" );
		if( output ) {
			int32 bytesWritten = ( int32 )fwrite( memory->base, 1, memory->used, output );
			Assert( bytesWritten == size );
			
			free( memory->base );
			fclose( output );
		} else {
			InvalidCodePath;
		}
	}
	
	{ // gen collision
		COLLISION_GEOMETRY__TEMP_BUFFER * tempBuffer = ( COLLISION_GEOMETRY__TEMP_BUFFER * )calloc( sizeof( COLLISION_GEOMETRY__TEMP_BUFFER ), 1 );
		
		for( int32 section_index = 0; section_index < 10; section_index++ ) {
			int32 indexA =     section_index;
			int32 indexB = ( ( section_index + 1 ) % 10 );
			
			vec3 * posA = floor_vertex + ( indexA * 8 );
			vec3 * posB = floor_vertex + ( indexB * 8 );
			
			for( int32 iter = 0; iter < 3; iter++ ) {
				int32 base = iter * 2;
				addQuad( tempBuffer, posA[ base + 0 ], posA[ base + 1 ], posA[ base + 3 ], posA[ base + 2 ] );
				addQuad( tempBuffer, posB[ base + 1 ], posA[ base + 0 ], posA[ base + 2 ], posB[ base + 3 ] );
			}
			
			addQuad( tempBuffer, posA[ 6 ], posA[ 7 ], posA[ 7 ] + offsetA, posA[ 6 ] + offsetA );
			addQuad( tempBuffer, posB[ 7 ], posA[ 6 ], posA[ 6 ] + offsetA, posB[ 7 ] + offsetA );
			
			addQuad( tempBuffer, posA[ 6 ] + offsetA, posA[ 7 ] + offsetA, posA[ 1 ] + offsetB, posA[ 0 ] + offsetB );
			addQuad( tempBuffer, posB[ 7 ] + offsetA, posA[ 6 ] + offsetA, posA[ 0 ] + offsetB, posB[ 1 ] + offsetB );
		}
	
		int32 baseIndex[] = { 0, 1, 2, 2, 3,   3, 3, 4, 4, 5,   5, 6, 7, 7, 8,   8, 8, 9, 9, 0, };
		for( int32 section_index = 0; section_index < 4; section_index++ ) {
			int32 indexA =     section_index;
			int32 indexB = ( ( section_index + 1 ) % 4 );
			
			int32 * base = baseIndex + ( section_index * 5 );
			
			vec3 pos[] = {
				court_pos[ indexA ], court_pos[ indexB ],  ( floor_vertex + ( base[ 0 ] * 8 ) )[ 1 ], ( floor_vertex + ( base[ 1 ] * 8 ) )[ 0 ],
				( floor_vertex + ( base[ 2 ] * 8 ) )[ 1 ], ( floor_vertex + ( base[ 3 ] * 8 ) )[ 0 ], ( floor_vertex + ( base[ 4 ] * 8 ) )[ 1 ], 
			};
			
			addQuad( tempBuffer, pos[ 1 ], pos[ 0 ], pos[ 2 ], pos[ 3 ] );
			addTri(  tempBuffer, pos[ 1 ], pos[ 3 ], pos[ 4 ] );
			addTri(  tempBuffer, pos[ 1 ], pos[ 4 ], pos[ 5 ] );
			addTri(  tempBuffer, pos[ 1 ], pos[ 5 ], pos[ 6 ] );
			
			for( int32 iter = 0; iter < 7; iter++ ) { pos[ iter ] += offsetB; }
			
			addQuad( tempBuffer, pos[ 3 ], pos[ 2 ], pos[ 0 ], pos[ 1 ] );
			addTri(  tempBuffer, pos[ 1 ], pos[ 4 ], pos[ 3 ] );
			addTri(  tempBuffer, pos[ 1 ], pos[ 5 ], pos[ 4 ] );
			addTri(  tempBuffer, pos[ 1 ], pos[ 6 ], pos[ 5 ] );
		}
		
		addQuad( tempBuffer, court_pos[ 3 ] + offsetB, court_pos[ 2 ] + offsetB, court_pos[ 1 ] + offsetB, court_pos[ 0 ] + offsetB );
		
		int32    collisionMemory_size = getSize3D( tempBuffer );
		MEMORY  _collisionMemory      = Memory( malloc( collisionMemory_size ), collisionMemory_size );
		MEMORY * collisionMemory      = &_collisionMemory;
		
		packGeometry3D( collisionMemory, tempBuffer );
	
		FILE * output = fopen( "../../art/stadiumFloor.col", "wb" );
		if( output ) {
			int32 bytesWritten = ( int32 )fwrite( collisionMemory->base, 1, collisionMemory->used, output );
			Assert( bytesWritten == collisionMemory_size );
			
			free( tempBuffer );
			free( collisionMemory->base );
			fclose( output );
		} else {
			InvalidCodePath;
		}
	}
}