
#ifdef	STD_INCLUDE_DECL

enum MESH_DRAW_TYPE {
	meshDrawType_null,
	
	meshDrawType_triangles,
	meshDrawType_triangleFan,
	meshDrawType_lines,
	meshDrawType_lineLoop,
	
	meshDrawType_count,
};

#endif	// STD_INCLUDE_DECL

#ifdef	STD_INCLUDE_FUNC

internal void
genDefaultMesh( ASSET_SYSTEM * assetSystem ) {
	vec3 point[] = {
		Vec3( -1.0f, -1.0f, -1.0f ), Vec3(  1.0f, -1.0f, -1.0f ),
		Vec3(  1.0f, -1.0f,  1.0f ), Vec3( -1.0f, -1.0f,  1.0f ),
		Vec3( -1.0f,  1.0f, -1.0f ), Vec3(  1.0f,  1.0f, -1.0f ),
		Vec3(  1.0f,  1.0f,  1.0f ), Vec3( -1.0f,  1.0f,  1.0f ),
	};
	
	vec2 texCoord[] = {
		Vec2( 0.0f, 0.0f ), Vec2( 1.0f, 0.0f ),
		Vec2( 1.0f, 1.0f ), Vec2( 0.0f, 1.0f ),
	};
	
	int32 vertex_count = 36;
	VERTEX_TEXMESH_3D * vertex_array = assetSystem->defaultMesh_vertices;
	vertex_array[  0 ] = VertexTexMesh3D( point[ 0 ], texCoord[ 0 ] );    vertex_array[  1 ] = VertexTexMesh3D( point[ 3 ], texCoord[ 1 ] );    vertex_array[  2 ] = VertexTexMesh3D( point[ 7 ], texCoord[ 2 ] );
	vertex_array[  3 ] = VertexTexMesh3D( point[ 0 ], texCoord[ 0 ] );    vertex_array[  4 ] = VertexTexMesh3D( point[ 7 ], texCoord[ 2 ] );    vertex_array[  5 ] = VertexTexMesh3D( point[ 4 ], texCoord[ 3 ] );
	vertex_array[  6 ] = VertexTexMesh3D( point[ 0 ], texCoord[ 0 ] );    vertex_array[  7 ] = VertexTexMesh3D( point[ 1 ], texCoord[ 1 ] );    vertex_array[  8 ] = VertexTexMesh3D( point[ 2 ], texCoord[ 2 ] );
	vertex_array[  9 ] = VertexTexMesh3D( point[ 0 ], texCoord[ 0 ] );    vertex_array[ 10 ] = VertexTexMesh3D( point[ 2 ], texCoord[ 2 ] );    vertex_array[ 11 ] = VertexTexMesh3D( point[ 3 ], texCoord[ 3 ] );
	vertex_array[ 12 ] = VertexTexMesh3D( point[ 1 ], texCoord[ 0 ] );    vertex_array[ 13 ] = VertexTexMesh3D( point[ 0 ], texCoord[ 1 ] );    vertex_array[ 14 ] = VertexTexMesh3D( point[ 4 ], texCoord[ 2 ] );
	vertex_array[ 15 ] = VertexTexMesh3D( point[ 1 ], texCoord[ 0 ] );    vertex_array[ 16 ] = VertexTexMesh3D( point[ 4 ], texCoord[ 2 ] );    vertex_array[ 17 ] = VertexTexMesh3D( point[ 5 ], texCoord[ 3 ] );
	vertex_array[ 18 ] = VertexTexMesh3D( point[ 2 ], texCoord[ 0 ] );    vertex_array[ 19 ] = VertexTexMesh3D( point[ 1 ], texCoord[ 1 ] );    vertex_array[ 20 ] = VertexTexMesh3D( point[ 5 ], texCoord[ 2 ] );
	vertex_array[ 21 ] = VertexTexMesh3D( point[ 2 ], texCoord[ 0 ] );    vertex_array[ 22 ] = VertexTexMesh3D( point[ 5 ], texCoord[ 2 ] );    vertex_array[ 23 ] = VertexTexMesh3D( point[ 6 ], texCoord[ 3 ] );
	vertex_array[ 24 ] = VertexTexMesh3D( point[ 7 ], texCoord[ 0 ] );    vertex_array[ 25 ] = VertexTexMesh3D( point[ 6 ], texCoord[ 1 ] );    vertex_array[ 26 ] = VertexTexMesh3D( point[ 5 ], texCoord[ 2 ] );
	vertex_array[ 27 ] = VertexTexMesh3D( point[ 7 ], texCoord[ 0 ] );    vertex_array[ 28 ] = VertexTexMesh3D( point[ 5 ], texCoord[ 2 ] );    vertex_array[ 29 ] = VertexTexMesh3D( point[ 4 ], texCoord[ 3 ] );
	vertex_array[ 30 ] = VertexTexMesh3D( point[ 3 ], texCoord[ 0 ] );    vertex_array[ 31 ] = VertexTexMesh3D( point[ 2 ], texCoord[ 1 ] );    vertex_array[ 32 ] = VertexTexMesh3D( point[ 6 ], texCoord[ 2 ] );
	vertex_array[ 33 ] = VertexTexMesh3D( point[ 3 ], texCoord[ 0 ] );    vertex_array[ 34 ] = VertexTexMesh3D( point[ 6 ], texCoord[ 2 ] );    vertex_array[ 35 ] = VertexTexMesh3D( point[ 7 ], texCoord[ 3 ] );
	
	assetSystem->defaultMesh = RenderMesh( meshDrawType_triangles, 36, assetSystem->defaultMesh_vertices );
}

#endif	// STD_INCLUDE_FUNC